; GUI #
;planet.c - This program shows how to composite modeling transformations
;to draw translated and rotated models. Interaction:  pressing the d and y keys
;(day and year) alters the rotation of the planet around the sun.
include win64a.inc
; --------------- 
WINDOWWIDTH  = 500
WINDOWHEIGHT = 500

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX       ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	TranslateMessage,edi
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local ps:PAINTSTRUCT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_CHAR
	je	wmCHAR
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCHAR: mov	eax,r8d
	cmp	al,'d';64h
	jne	@f
	add	day,10
	cmp	day,360
	jc	@0
	and	day,0
	jmp	@0
@@:	cmp	al,'D';44h
	jne	@f
	sub	day,10
	cmp	day,0
	jg	@0
	mov	day,360
	jmp	@0
@@:	cmp	al,'y'
	jne	@f
	add	year,5
	cmp	year,360
	jc	@0
	mov	year,0
	jmp	@0
@@:	cmp	al,'Y'
	jne	wmBYE
	sub	year,5
	cmp	year,0
	jg	@0
	mov	year,360
@0:     call	GLDisplay
	jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset pfd
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset pfd
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;GLInit-----------------------------------------
	invoke  glShadeModel, GL_FLAT
	invoke	GLReshape,WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	mov	edx,r9d
	movzx	ecx,dx
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	invoke  GLDisplay
;   
	lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
GLReshape proc w:dword,h:dword
local	resultq[2]:QWORD

	mov	w,ecx
	mov	h,edx
	fninit
	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode,GL_PROJECTION
	invoke  glLoadIdentity
	fild	w
	fidiv   h
	fstp    resultq
	movq	xmm3,constd20
	movq	xmm2,constd1
	movq	xmm1,resultq
	movq	xmm0,constd60
        invoke  gluPerspective
	invoke  glMatrixMode,GL_MODELVIEW
	invoke  glLoadIdentity
	movq	xmm3,rbx
	movq	xmm2,constd5
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke  gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx
	leave
	retn
GLReshape	endp
GLDisplay	proc
local	result:DWORD

	invoke  glClear,GL_COLOR_BUFFER_BIT
	mov	eax,const1
        movd	xmm2,eax
        movd	xmm1,eax
        movd	xmm0,eax
	invoke  glColor3f
	invoke  glPushMatrix
        movq	xmm0,constd1
	invoke  glutWireSphere,,20,16 ;draw sun
	fild    year
	fstp    result
        movd	xmm3,ebx
        movd	xmm2,const1
        movd	xmm1,ebx
        movd	xmm0,result
	invoke  glRotatef
        movd	xmm2,ebx
        movd	xmm1,ebx
        movd	xmm0,const2
	invoke  glTranslatef
	fild	day
	fstp    result
	movd	xmm3,ebx
	movd	xmm2,const1
	movd	xmm1,ebx
	movd	xmm0,result
	invoke  glRotatef
	movq	xmm0,constd0_2
	invoke  glutWireSphere,,10,8 ;draw smaller planet
	invoke  glPopMatrix
	invoke  SwapBuffers,hDC
	leave
	retn
GLDisplay	endp
;.data--------------------------------------------
hDC	dq	?
hrc	dq	?
pfd	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

const1		dd 1.0
const2		dd 2.0
constd1		dq 1.0
constd0_2	dq 0.2
constd5		dq 5.0
constd20	dq 20.0
constd60	dq 60.0
year		dd 0
day		dd 0
szClassName	db "Uncle Remus tales:#40 OpenGL - planet",0
FileName	db "br_Rabbit3.cur",0
end